/*  xAngle - xa-002: Scratch
 *  Copyright (C) Joakim Kolsj, Johan Larsson, Anders Asplund 2003
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GFX_CARACTER
#define GFX_CARACTER

#include "../basecode/surface.h"
#include "../basecode/global.h"

namespace demo
{
	namespace gfx
	{
		struct cha {
			pixel *p;
		};
		
		class caracter
		{
		public:
			caracter(surface *surface);
			void draw(long time, pixel *p);
		private:
			void draw_line(pixel *p, int x1, int y1, int x2, int y2);
			void draw_frame(pixel *p, pixel *frame, int x, int y);
			demo::surface *s;
		
			int width, height;
		
			// Frames
			cha *rp;
			int total_frames;
		
		};
	}
}

#endif
